<template>
  <div style="margin: 3rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton :isValidate="true" :offsetArrow="20" :spanTitle="3" title="Regresar" v-on:clickEvent="returnPage" style="margin-bottom:2.5rem"></ReturnButton>
    </header>

    <!-- COMPONENTE TITULO -->
    <div style="margin:3rem 6rem 0rem">
      <app-title Title="REVISIÓN DE MATERIALES TELEVISA" bgColor="background-color: #4A4A4A !important"> </app-title>
    </div> 
    <el-main style="margin:0rem 6rem; min-height: 300px">
      <el-row v-if="isNotContent" v-loading="loading" :element-loading-text="loadingText">
        <el-col :span="24" style="display: flex; justify-content: center;" v-show="!loading">
          <img src="@/assets/images/no-materiales.svg">
        </el-col>
      </el-row>
      <el-row v-else type="flex" style="flex-wrap: wrap">
        <!--LARGOMETRAJES -->
        <el-col :span="8" class="text-center" style="padding: 10px 50px 50px;" v-if="movCount>0">
          <app-cardReviewHome 
            @goTo="materialCanned('largometrajes', 'Largometrajes')" 
            :titleTop="true" :textTop="'Largometrajes'" 
            :titleBottom="false" 
            :styleTitleTop="'color-blue'" 
            :colorCaret="'color-lightblue'"
            :rutaImg="require(`@/assets/images/largometraje.svg`)" 
            :styleCard="'border-card-movie'">
          </app-cardReviewHome>
        </el-col>
        <!-- NOVELAS -->
        <el-col :span="8" class="text-center" style="padding: 10px 50px 50px;" v-if="novCount>0">
          <app-cardReviewHome 
            @goTo="materialCanned('novels', 'Novelas')" :titleTop="true" :textTop="'Novelas'" :titleBottom="false" :styleTitleTop="'color-pink'" :colorCaret="'color-blue'" :rutaImg="require(`@/assets/images/novela.svg`)" :styleCard="'border-card-novels'">
          </app-cardReviewHome>
        </el-col>
        <!-- SERIES -->
        <el-col :span="8" class="text-center" style="padding: 10px 50px 50px;" v-if="serCount>0">
          <app-cardReviewHome 
            @goTo="materialCanned('series', 'Series')" :titleTop="true" :textTop="'Series'" :titleBottom="false" :styleTitleTop="'color-lightblue'" :colorCaret="'color-pink'" :rutaImg="require(`@/assets/images/serie.svg`)" :styleCard="'border-card-series'">
          </app-cardReviewHome>
        </el-col>
        <!--MINISERIES -->
        <el-col class="text-center with-cards" style="padding: 10px 50px 50px;" v-if="minCount>0">
          <app-cardReviewHome 
            @goTo="materialCanned('miniseries', 'Miniseries')" 
            :titleTop="true" :textTop="'Miniseries'" 
            :titleBottom="false" 
            :styleTitleTop="'color-purple'" 
            :colorCaret="'color-yellow'"
            :rutaImg="require(`@/assets/images/miniserie.svg`)" 
            :styleCard="'border-card-miniseries'">
          </app-cardReviewHome>
        </el-col>
        <!--DIBUJOS -->
        <el-col class="text-center with-cards" style="padding: 10px 50px 50px;" v-if="carCount>0">
          <app-cardReviewHome 
            @goTo="materialCanned('cartoons', 'Dibujos')" 
            :titleTop="true" :textTop="'Dibujos'" 
            :titleBottom="false" 
            :styleTitleTop="'color-yellow'" 
            :colorCaret="'color-lightgreen'" 
            :rutaImg="require(`@/assets/images/dibujo.svg`)" 
            :styleCard="'border-card-cartoons'">
          </app-cardReviewHome>
        </el-col>
        <!-- ESPECIAL -->
        <el-col :span="8" class="text-center" style="padding: 10px 50px 50px;" v-if="specialsCount>0">
          <app-cardReviewHome 
            @goTo="materialCannedToGo('specials', 'Especial')" :titleTop="true" :textTop="'Especiales'" :titleBottom="false" :styleTitleTop="'color-lightgreen'" :colorCaret="'color-purple'" :rutaImg="require(`@/assets/images/especiales.svg`)" :styleCard="'border-card-specials'">
          </app-cardReviewHome>
        </el-col>
        <!----COCINA--->
        <el-col class="text-center with-cards" style="padding: 10px 50px 50px;" v-if="cookCounter>0">
          <app-cardReviewHome
            @goTo="materialCannedToGo('cook', 'Cocina')"
            :titleTop="true" 
            :textTop="'Cocina'" 
            :titleBottom="false" 
            :styleTitleTop="'color-gold'" 
            :colorCaret="'color-gray'"
            :rutaImg="require(`@/assets/images/icono-cocina.svg`)" 
            :styleCard="'border-card-cook'">
          </app-cardReviewHome>
        </el-col>
        <!----CÓMICO--->
        <el-col class="text-center with-cards" style="padding: 10px 50px 50px;" v-if="comicCounter>0">
          <app-cardReviewHome
            @goTo="materialCannedToGo('comic', 'Cómico')"
            :titleTop="true" 
            :textTop="'Cómico'" 
            :titleBottom="false" 
            :styleTitleTop="'color-lightpurple'" 
            :colorCaret="'color-purple'"
            :rutaImg="require(`@/assets/images/icono-cómico.svg`)" 
            :styleCard="'bg-lightpurple'">
          </app-cardReviewHome>
        </el-col>
        <!----DEPORTIVO--->
        <el-col class="text-center with-cards" style="padding: 10px 50px 50px;" v-if="deportCounter>0">
          <app-cardReviewHome
            @goTo="materialCannedToGo('deport', 'Deporte')"
            :titleTop="true" 
            :textTop="'Deportivo'" 
            :titleBottom="false" 
            :styleTitleTop="'color_light_blue'" 
            :colorCaret="'color-lightpurple'"
            :rutaImg="require(`@/assets/images/icono-deportivo.svg`)" 
            :styleCard="'bg-lightblue'">
          </app-cardReviewHome>
        </el-col>
        <!----ENTRETENIMIENTO--->
        <el-col class="text-center with-cards" style="padding: 10px 50px 50px;" v-if="entertainmentCounter>0">
          <app-cardReviewHome
            @goTo="materialCannedToGo('entreteiment', 'Entretenimiento')"
            :titleTop="true" 
            :textTop="'Entretenimiento'" 
            :titleBottom="false" 
            :styleTitleTop="'color-pink-card'" 
            :colorCaret="'color-darkblue'"
            :rutaImg="require(`@/assets/images/icono-entretenimiento.svg`)" 
            :styleCard="'bg-pinkCard'">
          </app-cardReviewHome>
        </el-col>
        <!----ENTREVISTA--->
        <el-col class="text-center with-cards" style="padding: 10px 50px 50px;" v-if="interviewCounter>0">
          <app-cardReviewHome
            @goTo="materialCannedToGo('interview', 'Entrevista')"
            :titleTop="true" 
            :textTop="'Entrevista'" 
            :titleBottom="false" 
            :styleTitleTop="'color-magenta'" 
            :colorCaret="'color-darkpink'"
            :rutaImg="require(`@/assets/images/icono-entrevista.svg`)"
            :styleCard="'border-card-interview'">
          </app-cardReviewHome>
        </el-col>
        <!----INFANTIL--->
        <el-col class="text-center with-cards" style="padding: 10px 50px 50px;" v-if="childCounter>0">
          <app-cardReviewHome
            @goTo="materialCannedToGo('childs', 'Infantil')"
            :titleTop="true" 
            :textTop="'Infantil'" 
            :titleBottom="false" 
            :styleTitleTop="'color-card-child'" 
            :colorCaret="'color-purple'"
            :rutaImg="require(`@/assets/images/icono-infantil.svg`)"
            :styleCard="'border-card-child'">
          </app-cardReviewHome>
        </el-col>
        <!----MAGAZINE--->
        <el-col class="text-center with-cards" style="padding: 10px 50px 50px;" v-if="magazineCounter>0">
          <app-cardReviewHome
            @goTo="materialCannedToGo('magazine', 'Magazine')"
            :titleTop="true" 
            :textTop="'Magazine'" 
            :titleBottom="false" 
            :styleTitleTop="'color-green'" 
            :colorCaret="'color-card-child'"
            :rutaImg="require(`@/assets/images/icono-magazine.svg`)"
            :styleCard="'border-card-magazine'">
          </app-cardReviewHome>
        </el-col>
        <!----MICROPROGRAMA--->
        <el-col class="text-center with-cards" style="padding: 10px 50px 50px;" v-if="microprogramCounter>0">
          <app-cardReviewHome
            @goTo="materialCannedToGo('microprogram', 'Microprograma')"
            :titleTop="true" 
            :textTop="'Microprograma'" 
            :titleBottom="false" 
            :styleTitleTop="'color-lightgray'" 
            :colorCaret="'color-darkpink'"
            :rutaImg="require(`@/assets/images/icono-microprograma.svg`)"
            :styleCard="'border-card-microprograma'">
          </app-cardReviewHome>
        </el-col>
        <!----PERIODISTICO--->
        <el-col class="text-center with-cards" style="padding: 10px 50px 50px;" v-if="periodisticoCounter>0">
          <app-cardReviewHome
          @goTo="materialCannedToGo('periodístico', 'Periodístico')"
            :titleTop="true" 
            :textTop="'Periodístico'" 
            :titleBottom="false" 
            :styleTitleTop="'color-darkmagenta'" 
            :colorCaret="'color-gray'"
            :rutaImg="require(`@/assets/images/icono-periodístico.svg`)"
            :styleCard="'border-card-periodistico'">
          </app-cardReviewHome>
        </el-col>
        <!----PROGRAMAS ESPECIALES--->
        <el-col class="text-center with-cards" style="padding: 10px 50px 50px;" v-if="programEspecialCounter>0">
          <app-cardReviewHome
            @goTo="materialCannedToGo('programsEspecial', 'Programas Especiales')"
            :titleTop="true" 
            :textTop="'Programas Especiales'" 
            :titleBottom="false" 
            :styleTitleTop="'color-greenApple'" 
            :colorCaret="'color-gold'"
            :isBigLetters="true"
            :rutaImg="require(`@/assets/images/icono-progespeciales.svg`)"
            :styleCard="'border-card-prog-especial'">
          </app-cardReviewHome>
        </el-col>
        <!----RELIGIOSO--->
        <el-col class="text-center with-cards" style="padding: 10px 50px 50px;" v-if="religiousCounter>0">
          <app-cardReviewHome
            @goTo="materialCannedToGo('religious', 'Religioso')"
            :titleTop="true" 
            :textTop="'Religioso'" 
            :titleBottom="false" 
            :styleTitleTop="'color-aqua'" 
            :colorCaret="'color-card-child'"
            :rutaImg="require(`@/assets/images/icono-religioso.svg`)"
            :styleCard="'border-card-religious'">
          </app-cardReviewHome>
        </el-col>
        <!----TALKSHOW--->
        <el-col class="text-center with-cards" style="padding: 10px 50px 50px;" v-if="talkshowCounter>0">
          <app-cardReviewHome
            @goTo="materialCannedToGo('talkshow', 'Talkshow')"
            :titleTop="true" 
            :textTop="'Talkshow'" 
            :titleBottom="false" 
            :styleTitleTop="'color-darkpink'" 
            :colorCaret="'color-magenta'"
            :rutaImg="require(`@/assets/images/icono-talkshow.svg`)"
            :styleCard="'border-card-talkshow'">
          </app-cardReviewHome>
        </el-col>
        <!----ELECTORAL--->
        <el-col class="text-center with-cards" style="padding: 10px 50px 50px;" v-if="electoralCounter>0">
          <app-cardReviewHome
            @goTo="materialCannedToGo('electoral', 'Electoral')"
            :titleTop="true" 
            :textTop="'Electoral'" 
            :titleBottom="false" 
            :styleTitleTop="'color-darkred'" 
            :colorCaret="'color-aqua'"
            :rutaImg="require(`@/assets/images/icono-electoral.svg`)"
            :styleCard="'border-card-electoral'">
          </app-cardReviewHome>
        </el-col>
        <!----FEMENINO--->
        <el-col class="text-center with-cards" style="padding: 10px 50px 50px;" v-if="femaleCounter>0">
          <app-cardReviewHome
            @goTo="materialCannedToGo('female', 'Femenino')"
            :titleTop="true" 
            :textTop="'Femenino'" 
            :titleBottom="false" 
            :styleTitleTop="'color-darkpurple'" 
            :colorCaret="'color-pink-card'"
            :rutaImg="require(`@/assets/images/icono-femenino.svg`)"
            :styleCard="'border-card-femenino'">
          </app-cardReviewHome>
        </el-col>
        <!----POLITICO--->
        <el-col class="text-center with-cards" style="padding: 10px 50px 50px;" v-if="politicalCounter>0">
          <app-cardReviewHome
            @goTo="materialCannedToGo('politic', 'Político')"
            :titleTop="true" 
            :textTop="'Político'" 
            :titleBottom="false" 
            :styleTitleTop="'color-darkblue'" 
            :colorCaret="'color-darkmagenta'"
            :rutaImg="require(`@/assets/images/icono-político.svg`)"
            :styleCard="'border-card-politico'">
          </app-cardReviewHome>
        </el-col>
      </el-row>
    </el-main>
  </div>
</template>

<script>
// @ is an alias to /src
import ReturnButton from '@/components/ReturnButton.vue'
import cardReviewHome from '@/components/cardReviewHome.vue'
import Title from '@/components/Title.vue'
import { HTTP } from '@/main.js'

export default {
  components: {
    'app-cardReviewHome': cardReviewHome,
    'app-title': Title,
    ReturnButton
  },
  data () {
    return {
      /*Afiliados*/
      televisaNovel: 0,
      ingridNovel: 0,
      televisaSerie: 0,
      ingridSerie: 0,
      televisaSpecial: 0,
      ingridSpecial: 0,
      movCount: 0,
      minCount: 0,
      carCount: 0,
      loading: true,
      loadingText: 'Cargando Materiales Televisa...',
      /*Add new cards*/
      cookCounter: 0,
      comicCounter: 0,
      deportCounter: 0,
      entertainmentCounter: 0,
      interviewCounter: 0,
      childCounter: 0,
      magazineCounter: 0,
      microprogramCounter: 0,
      periodisticoCounter: 0,
      programEspecialCounter: 0,
      religiousCounter: 0,
      talkshowCounter: 0,
      electoralCounter: 0,
      femaleCounter: 0,
      politicalCounter: 0
    }
  },
  created () {
    /*MATERIALES TELEVISA*/
    // Novelas
    this.getMaterial('TELEVISA - TELENOVELAS', 'televisaNovel')
    this.getMaterialsDeAfiliado('Novelas', 'ingridNovel')
    // Series
    this.getMaterial('TELEVISA - SERIES', 'televisaSerie')
    this.getMaterialsDeAfiliado('Series', 'ingridSerie')
    // Especial
    this.getMaterial('TELEVISA - ESPECIALES', 'televisaSpecial')
    this.getMaterialsDeAfiliado('Especial', 'ingridSpecial')

    /*Add new cards*/
    this.getMaterialsDeAfiliado('Largometrajes', 'movCount')
    this.getMaterialsDeAfiliado('Miniseries', 'minCount')
    this.getMaterialsDeAfiliado('Dibujos', 'carCount')
    this.getMaterialsDeAfiliado('Cocina', 'cookCounter')


    this.getMaterialsDeAfiliado('Cómico', 'comicCounter')
    this.getMaterialsDeAfiliado('Deportes', 'deportCounter')
    this.getMaterialsDeAfiliado('Entretenimiento', 'entertainmentCounter')
    this.getMaterialsDeAfiliado('Entrevista', 'interviewCounter')
    this.getMaterialsDeAfiliado('Infantil', 'childCounter')
    this.getMaterialsDeAfiliado('Magazine', 'magazineCounter')
    this.getMaterialsDeAfiliado('Microprograma', 'microprogramCounter')
    this.getMaterialsDeAfiliado('Periodístico', 'periodisticoCounter')
    this.getMaterialsDeAfiliado('Programas Especiales', 'programEspecialCounter')
    this.getMaterialsDeAfiliado('Religioso', 'religiousCounter')
    this.getMaterialsDeAfiliado('Talkshow', 'talkshowCounter')
    this.getMaterialsDeAfiliado('Electoral', 'electoralCounter')
    this.getMaterialsDeAfiliado('Femenino', 'femaleCounter')
    this.getMaterialsDeAfiliado('Político', 'politicalCounter')
    this.viewHaveContent(this.isNotContent)

  },
  computed: {
    multiplerFilter() {
      const array = [
        this.movCount,
        this.novCount,
        this.serCount,
        this.minCount,
        this.carCount,
        this.specialsCount,
        this.cookCounter,
        this.comicCounter,
        this.deportCounter,
        this.entertainmentCounter,
        this.interviewCounter,
        this.childCounter,
        this.magazineCounter,
        this.microprogramCounter,
        this.periodisticoCounter,
        this.programEspecialCounter,
        this.religiousCounter,
        this.talkshowCounter,
        this.electoralCounter,
        this.femaleCounter,
        this.politicalCounter
      ].join()
      return array
    },
    isNotContent() {
      if(
        this.movCount == 0 &&
        this.novCount == 0 &&
        this.serCount == 0 &&
        this.minCount == 0 &&
        this.carCount == 0 &&
        this.specialsCount == 0 &&
        this.cookCounter == 0 &&
        this.comicCounter == 0 &&
        this.deportCounter == 0 &&
        this.entertainmentCounter == 0 &&
        this.interviewCounter == 0 &&
        this.childCounter == 0 &&
        this.magazineCounter == 0 &&
        this.microprogramCounter == 0 &&
        this.periodisticoCounter == 0 &&
        this.programEspecialCounter == 0 &&
        this.religiousCounter == 0 &&
        this.talkshowCounter == 0 &&
        this.electoralCounter == 0 &&
        this.femaleCounter == 0 &&
        this.politicalCounter == 0
      ) {
        return true
      } else {
        return false
      }
    },
    novCount(){
      let totalNovels = this.ingridNovel + this.televisaNovel
      return totalNovels
    },
    serCount(){
      let totalSeries = this.ingridSerie + this.televisaSerie
      return totalSeries
    },
    specialsCount(){
      let totalSpecials = this.ingridSpecial + this.televisaSpecial
      return totalSpecials
    },
  },
  methods: {
    viewHaveContent(data) {
      if(data == true) {
        setTimeout(() => {
          this.loading = false
        }, 1000)
      }
    },
    materialCannedToGo(query, subTitle) {
      console.log(query, 'query')
      console.log(subTitle, 'subTitle')
      this.$localStorage.set('typeOfContent', subTitle)
      this.$router.push({ name: "tipoDeMaterial",  params: {name: subTitle}});
    },
    getMaterial(material, value){
      HTTP.get('materials/materialType/'+material)
        .then(res => {
          let arrMaterial = res.data.count
          this[value] = arrMaterial
        })
        .catch(err => {
          console.log(err);
        });
    },
    getMaterialsDeAfiliado (material, arrTotal) {
      HTTP.get('materials/materialType/Televisa/typeOfContent/' + material + '/providerName')
      .then(res => {
        let arrOfMaterial = res.data.materials
        this[arrTotal] = arrOfMaterial.length
      })
      .catch(err => console.log(err))
    },
    returnPage () {
      this.$router.push({ name: 'revListaAfiliados'})
    },
    materialCanned(mtype, string) {
      this.$localStorage.set('afiliado', true )
      if( mtype !== 'novels' && mtype !== 'cartoons' && mtype !== 'series') {
        this.$localStorage.set('typeMaterialR', string)
        this.$router.push({ name: mtype, params: { canned: true } });
      }
      else {
        this.$router.push({ name: 'novels', params: { canned: true } });
        this.$localStorage.set('typeMaterialR', string)
				// this.$localStorage.set('enlatado', true )
      }
    },
  },
  watch: {
    multiplerFilter(val) {
      if(
        this.movCount !== 0 &&
        this.novCount !== 0 &&
        this.serCount !== 0 &&
        this.minCount !== 0 &&
        this.carCount !== 0 &&
        this.specialsCount !== 0 &&
        this.cookCounter!== 0 &&
        this.comicCounter!== 0 &&
        this.deportCounter!== 0 &&
        this.entertainmentCounter!== 0 &&
        this.interviewCounter!== 0 &&
        this.childCounter!== 0 &&
        this.magazineCounter!== 0 &&
        this.microprogramCounter!== 0 &&
        this.periodisticoCounter!== 0 &&
        this.programEspecialCounter!== 0 &&
        this.religiousCounter!== 0 &&
        this.talkshowCounter!== 0 &&
        this.electoralCounter!== 0 &&
        this.femaleCounter !== 0 &&
        this.politicalCounter
      ) {
        this.loading = false
      } else {
        this.loading = true
      }
    }
  }
}
</script>